package com.dingding.mid.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 工作流配置
 *
 * @author yx
 * @date 2024/02/24
 */
@Data
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "工作流配置")
@TableName("workflow_config")
public class WorkflowConfig extends Model<WorkflowConfig> {
    private static final long serialVersionUID = -5103342029449059474L;

    @TableId(type = IdType.ASSIGN_UUID)
    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "表单名称")
    private String formName;

    @ApiModelProperty(value = "表名")
    private String tableName;

    @ApiModelProperty(value = "审批类型：1.手动审批；2.工作流审批")
    private String approvalType;

    @ApiModelProperty(value = "实体json")
    private String entityJson;

    @ApiModelProperty(value = "园区code")
    private String parkCode;

    @ApiModelProperty(value = "企业code")
    private String companyCode;

    @ApiModelProperty(value = "租户id")
    private Integer tenantId;

}
