package com.dingding.mid.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.dingding.mid.entity.ProcessTemplates;
import com.dingding.mid.param.ProcessTemplatesParam;
import com.dingding.mid.vo.ProcessTemplatesVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author : willian fu
 * @date : 2020/9/21
 */
@Mapper
public interface ProcessTemplatesMapper extends BaseMapper<ProcessTemplates> {

    /**
     * 查询表单模板
     *
     * @param param param
     * @return {@link IPage}<{@link ProcessTemplatesVO}>
     */
    List<ProcessTemplatesVO> getFormPage(@Param("param") ProcessTemplatesParam param);

    /**
     * 获取表单pagev2
     *
     * @param page  第页
     * @param param param
     * @return {@link IPage}<{@link ProcessTemplatesVO}>
     */
    IPage<ProcessTemplatesVO> getFormPagev2(Page page, @Param("param") ProcessTemplatesParam param);


    /**
     * 按用户id获取用户名
     *
     * @param userId 用户id
     * @return {@link String}
     */
    String getUserNameByUserId(@Param("userId") String userId);
}
