package com.dingding.mid.mqtt;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

@Data
@Accessors(chain = true)
public class CloudMessage implements Serializable{

    private static final long serialVersionUID = 8960918892403582806L;

    /**
     * SINGLE_MESSAGE 一对一   ROLE_GROUP_MESSAGE  根据角色群发
     *
     */
//    @ApiModelProperty(value="消息命令")
//    private String command;

    /**
     * SINGLE_MESSAGE 一对一   ROLE_GROUP_MESSAGE  根据角色群发
     *
     */
//    @ApiModelProperty(value="消息命令")
//    private String command;

    /**
     * 0 未读   1已读
     */
    @ApiModelProperty(value="0 未读   1已读   2删除")
    private Integer messageStatus;


    /**
     * 0 待处理  1已处理
     */
    @ApiModelProperty(value="0 待处理  1已处理")
    private Integer dealStatus;

    /**
     * 收件人uid
     */
    @ApiModelProperty(value="收件人uid")
    private String receiveBy;

    /**
     * 发送时间
     */
    @ApiModelProperty(value="发送时间")
    private LocalDateTime createTime;

    /**
     * 收件人名字
     */
    @ApiModelProperty(value="收件人名字")
    private String receiveUser;

    /**
     * 类型名字
     */
    @ApiModelProperty(value="数据类型名字")
    private String typeName;

    /**
     * 消息等级
     */
    @ApiModelProperty(value="消息等级 0 普通  1重要  2紧急")
    private Integer messageLevel;

    /**
     * 标题
     */
    @ApiModelProperty(value="标题")
    private String title;

    /**
     * 内容
     */
    @ApiModelProperty(value="内容")
    private String content;

    /**
     * 关联id
     */
    @ApiModelProperty(value="关联id")
    private String outId;

    /**
     *模块
     */
    @ApiModelProperty(value="模块")
    private String module;

    @ApiModelProperty(value="类型id")
    private Integer messageTypeId;

    /**
     * 类型
     */
    @ApiModelProperty(value="类型")
    private String typeCode;

    /**
     * 扩展信息
     */
    @ApiModelProperty(value="扩展信息")
    private String extend;

    /**
     * 任务id
     */
    @ApiModelProperty(value="任务id")
    private String taskId;

}
