package com.dingding.mid.service;

import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;

import com.dingding.mid.mqtt.CloudMessage;
import com.dingding.mid.mqtt.CloudUser;
import com.dingding.mid.mqtt.MqttMessage;
import com.dingding.mid.mqtt.WorkFlowMessage;
import net.dreamlu.iot.mqtt.spring.client.MqttClientTemplate;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.nio.charset.StandardCharsets;
import java.time.LocalDateTime;

@Service
public class SendMessageService {
    private static final Logger logger = LoggerFactory.getLogger(SendMessageService.class);
    @Autowired
    private MqttClientTemplate client;

    public boolean publish(String topic,JSONObject mqttMessage) {
        JSONObject jsonObject = JSONUtil.parseObj(mqttMessage);
        client.publish(topic, JSONUtil.toJsonStr(jsonObject).getBytes(StandardCharsets.UTF_8));
        return true;
    }

    public boolean publish(String topic,CloudMessage cloudMessage) {
        JSONObject jsonObject = JSONUtil.parseObj(cloudMessage);
        client.publish(topic, JSONUtil.toJsonStr(jsonObject).getBytes(StandardCharsets.UTF_8));
        return true;
    }

    public boolean publish(String topic, WorkFlowMessage workFlowMessage) {
        JSONObject jsonObject = JSONUtil.parseObj(workFlowMessage);
        return client.publish(topic, JSONUtil.toJsonStr(jsonObject).getBytes(StandardCharsets.UTF_8));
    }

//    public boolean publish(String topic, MqttMessage mqttMessage, MqttProperties mqttProperties) {
//        JSONObject jsonObject = JSONUtil.parseObj(mqttMessage);
//        JSONObject mqttJson = JSONUtil.parseObj(mqttProperties);
//        jsonObject.putAll(mqttJson);
//        client.publish(topic, JSONUtil.toJsonStr(jsonObject).getBytes(StandardCharsets.UTF_8));
//        return true;
//    }

    public static MqttMessage fomatMessage(String command, String content, Integer roomId, CloudUser cloudUser) {
        MqttMessage message = new MqttMessage();
        message.setContent(content);
        message.setNickname(cloudUser.getNickname());
        message.setUserId(cloudUser.getId());
        message.setOptionTime(LocalDateTime.now());
        message.setRoomId(roomId);
        message.setCommand(command);
        return message;
    }
    public static MqttMessage fomatMessage(String command, String content, Integer roomId, String nickname,Integer userId) {
        MqttMessage message = new MqttMessage();
        message.setContent(content);
        message.setNickname(nickname);
        message.setUserId(userId);
        message.setOptionTime(LocalDateTime.now());
        message.setRoomId(roomId);
        message.setCommand(command);
        return message;
    }

    public static CloudMessage fomatNormalMessage(String title, String content
            , String typeName, Integer messageLevel, String toUser, String toUserName, String outId) {
        CloudMessage cloudMessage = new CloudMessage();
        cloudMessage.setCreateTime(LocalDateTime.now());
        cloudMessage.setTitle(title);
        cloudMessage.setContent(content);
        cloudMessage.setTypeName(typeName);
        cloudMessage.setMessageLevel(messageLevel);
        cloudMessage.setReceiveBy(toUser);
        cloudMessage.setModule("reply_message");
        cloudMessage.setTypeCode("reply_message");
        cloudMessage.setReceiveUser(toUserName);
        cloudMessage.setMessageStatus(0);
        cloudMessage.setDealStatus(0);
        return cloudMessage;
    }
}
